<html lang="en">
<head>
<title>Polyline sweeps with closure - Sketch</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Sketch">
<meta name="generator" content="makeinfo 4.7">
<link title="Top" rel="start" href="index.html#Top">
<link rel="up" href="Swept-objects.html#Swept-objects" title="Swept objects">
<link rel="prev" href="Polygon-sweeps.html#Polygon-sweeps" title="Polygon sweeps">
<link rel="next" href="Affine-arithmetic.html#Affine-arithmetic" title="Affine arithmetic">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<!--
Copyright (C) 2005, 2006, 2007, 2008 Eugene K. Ressler.

This manual is for `sketch', version 0.2 (build 161),
Tuesday, September 08, 2009, a program that converts descriptions of simple
three-dimensional scenes into static drawings. This version generates
`PSTricks' or `PGF/TikZ' code suitable for use with the
TeX document processing system.

`Sketch' is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3, or (at your option)
any later version.

Sketch is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with `sketch'; see the file COPYING.txt.  If not, see
http://www.gnu.org/copyleft.-->
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc { font-variant:small-caps }
  span.roman { font-family: serif; font-weight: normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="Polyline-sweeps-with-closure"></a>Next:&nbsp;<a rel="next" accesskey="n" href="Affine-arithmetic.html#Affine-arithmetic">Affine arithmetic</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="Polygon-sweeps.html#Polygon-sweeps">Polygon sweeps</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="Swept-objects.html#Swept-objects">Swept objects</a>
<hr><br>
</div>

<!-- node-name,  next,  previous,  up -->
<h4 class="subsection">2.7.5 Polyline sweeps with closure</h4>

<p>A polyline sweep with a closure tag
<a name="index-_003c_003e_0040r_007b_002c-closure-tag_007d-136"></a><a name="index-closure-tag_002c-_0040code_007b_003c_003e_007d-137"></a>creates another kind of closed
surface.  First, the polyline segments are connected by faces, just as
without the closure tag.  Then, each set of end points is joined to
make a polygon, one for each end.  A code for several views of a
cylindrical prism follows. 
<a name="index-def-138"></a><a name="index-repeat-139"></a><a name="index-rotate-140"></a><a name="index-then-141"></a><a name="index-translate-142"></a><a name="index-sweep-143"></a><a name="index-line-144"></a><a name="index-fillcolor-145"></a>
<pre class="verbatim">
  def n_cyl_segs 20  def n_views 5  def I [1,0,0]
  def endopts [fillcolor=lightgray]
  repeat { n_views, rotate(180/n_views, [I]) then translate([I] * 2.1) } 
    sweep[endopts]{ n_cyl_segs&lt;>, rotate(360/n_cyl_segs, [0,1,0]) } 
      line[fillcolor=white](1,-1)(1,1)
</pre>
It produces this drawing.

<div align="center"><img src="ex110.png" alt="ex110.png"></div>

<p class="noindent">The options of the swept line, if any, are applied to the faces
produced by sweeping the line, but not the end polygons.  Otherwise,
the sweep options are applied throughout. 
<a name="index-options_002c-swept-object-146"></a>The <tt>def</tt> in this example is an <dfn>option</dfn> definition. 
<a name="index-definition_002c-options-147"></a><a name="index-options-definition-148"></a>References to options must be enclosed in square brackets, e.g.&nbsp;<!-- /@w -->
<tt>[foo]</tt>. 
<a name="index-reference_002c-options-149"></a><a name="index-_005bfoo_005d_0040r_007b_002c-options-reference_007d-150"></a>You can concatenate several sets of options with a single
reference, e.g.&nbsp;<!-- /@w -->
<tt>[color, size, style]</tt>
would cause the option definitions for <code>color</code>, <code>size</code>,
and <code>style</code> to appear in sequence in the output
created by the <code>sketch</code> command containing the reference. 
Happily, the syntax of <code>sketch</code> is such that
options references can never be confused with vector references.  While
not apparent in this example, options references are useful when
defining many objects with a similar appearance.

   </body></html>

